# cs107-FinalProject
## Group 17
### Team Members: Jeffrey Mayolo, Eric Helmold, Ziye Tao, Manu Penenory

## Broader Impact and Inclusivity Statement

### Broader Impact

Although there aren’t many ways to misuse calculating derivatives or our project directly. 
Some of the applications of automatic differentiation have the power to be potentially misused.
As discussed earlier, automatic differentiation can be applied to almost every field of science and engineering, and it can also be applied to machine learning and optimization. 
From these applications of our project, various serious consequences can arise. To prevent this from happening, as will be discussed below, we will carefully review all pull-requests and contributions to our code-base, making sure all edits are not disadvantageous to anyone.

### Software Inclusivity
Computer science as a subject presents many barriers to underrepresented groups. 
Many minorities including women, Black, Latinx, and Native Americans groups compose a smaller percentage of those who study computer science. 
Computer science as a whole requires a level of experience with computers, computer programming background, and mathematics, which is not always offered or accessible to all. 
Our project includes some subtle barriers to using and understanding it. 
Particularly, understanding our project and its implementation requires an in-depth understanding of git version control, calculus, and programming in python. 
This already excludes various underrepresented groups who don't have prior knowledge to many of these elements that have composed our project. Our project, being complex in its implementation, makes it inaccessible to those who are unfamiliar with how to use github and version control to contribute and include new creative ideas. 
However, our group strived to be as inclusive as possible with our project. Coming from different cultural backgrounds, having different life-perspectives, and representing different genders, we believe our code is accessible to the vast majority of people. 
We speak a diverse array of languages, including four of the most popular languages English, Mandarin, French, and Spanish, which will help us communicate to future groups who will want to utilize our project.

When reviewing pull requests created by developers for our project, we will do so in an unbiased and fair manner. 
A randomized team of us will review the changes, whether minor or major changes, that the developer wants to include and incorporate into the project. 
The developers will also be welcome to leave any questions, concerns, or ideas in the comments section of the pull request. 
Software inclusivity is something that we have sought to emphasize throughout the creation of our project.

[![build](https://github.com/cs107-MPHT/cs107-FinalProject/actions/workflows/workflow.yml/badge.svg?branch=final_touches)](https://github.com/cs107-FinalProject/actions/workflows/workflow.yml)
[![codecov](https://codecov.io/gh/cs107-MPHT/cs107-FinalProject/branch/final_project/graph/badge.svg?token=3852f02c-e0a1-412a-9755-1939e207dbf5)](https://codecov.io/gh/cs1-7-MPHT/cs107-FinalProject)